package dev.shadowsoffire.apotheosis.adventure.loot;

import java.util.function.Function;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import net.minecraftforge.common.loot.IGlobalLootModifier;
import net.minecraft.world.entity.player.Player;
import java.util.Iterator;
import net.minecraft.world.level.ServerLevelAccessor;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.Apotheosis;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.item.ItemStack;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition;
import com.mojang.serialization.Codec;
import net.minecraftforge.common.loot.LootModifier;

public class AffixLootModifier extends LootModifier
{
    public static final Codec<AffixLootModifier> CODEC;
    
    protected AffixLootModifier(final LootItemCondition[] conditionsIn) {
        super(conditionsIn);
    }
    
    protected ObjectArrayList<ItemStack> doApply(final ObjectArrayList<ItemStack> generatedLoot, final LootContext context) {
        if (!Apotheosis.enableAdventure) {
            return generatedLoot;
        }
        for (final AdventureConfig.LootPatternMatcher m : AdventureConfig.AFFIX_ITEM_LOOT_RULES) {
            if (m.matches(context.getQueriedLootTableId())) {
                if (context.m_230907_().m_188501_() > m.chance()) {
                    break;
                }
                final Player player = GemLootPoolEntry.findPlayer(context);
                if (player == null) {
                    return generatedLoot;
                }
                final ItemStack affixItem = LootController.createRandomLootItem(context.m_230907_(), null, player, (ServerLevelAccessor)context.m_78952_());
                if (affixItem.m_41619_()) {
                    break;
                }
                affixItem.m_41783_().m_128379_("apoth_rchest", true);
                generatedLoot.add((Object)affixItem);
                break;
            }
        }
        return generatedLoot;
    }
    
    public Codec<? extends IGlobalLootModifier> codec() {
        return (Codec<? extends IGlobalLootModifier>)AffixLootModifier.CODEC;
    }
    
    static {
        CODEC = RecordCodecBuilder.create(inst -> codecStart(inst).apply((Applicative)inst, (Function)AffixLootModifier::new));
    }
}
